unit Dep;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls,inifiles;

type
  TForm2 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    ComboBox1: TComboBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Image1: TImage;
    Image2: TImage;
    procedure Button2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ublic:boolean;
  Form2: TForm2;
  stri:string;
  ini:tinifile;
  wni:tinifile;
  pix:array[0..7,0..7] of boolean;
  pixrow:byte;
  mx:integer;
  my:integer;
  md:boolean;
  tc:boolean;
  tb:tbitmap;
  sec:tstringlist;
  ll,lo:tstringlist;
  implementation

{$R *.DFM}
function lefto(stringo,seperato:string):string; begin
result:=copy(stringo,0,pos(seperato,stringo)-1);
end;


function booltostr(bool:boolean):string; begin
if(bool=true)then begin result:='true'; end;
if(bool=false)then begin result:='false';end;
end;
function booltoint(bool:boolean):byte;begin
if(bool=true)then begin result:=1; end;
if(bool=false)then begin result:=0;end;
end;

function strtobool(str:string):boolean; begin
if(str='true') then begin result:=true; end else
if(str='yes') then begin result:=true; end else
if(str='on') then begin result:=true; end else
if(str='1') then begin result:=true; end else
if(str='false') then begin result:=false; end else
if(str='no') then begin result:=false; end else
if(str='off') then begin result:=false; end else
if(str='0') then begin result:=false; end else
begin result:=false; end;
end;



function inttobin(Value: Longint): string;
var
  Ch: Char;
begin
  Result :='';
  repeat
    Ch :='0';
    Inc(Ch, Value mod 2);
    if Ch >'9' then Inc(Ch, 7);
    Insert( Ch, Result, 1);
    Value :=Value div 2;
  until Value =0;
end;


function strtobin(st:string):integer;
var i,x,d,rslt:integer;
begin
x:=length(st);i:=0;d:=1;rslt:=0;
while x>0 do begin
x:=x-1;i:=i+1;
rslt:=rslt+(strtoint(st[x+1])*d);
d:=d*2;
end;
result:=rslt;
end;


function righto(stringon,seperaton:string):string; begin
result:=copy(stringon,pos(seperaton,stringon)+1,length(stringon));
end;


function getstrdex(st,ss:string;tn:integer):string;
var x:integer;
var tok:integer;
begin
x:=0;tok:=0;result:='';
while x<length(st) do begin
x:=x+1;
if st[x]=ss then begin tok:=tok+1;end;
if (tok=tn)and not(st[x]=ss) then begin result:=result+st[x];end;
end;
end;



function fillit(eheh,ahha:tbitmap):byte;
var wu,wn:integer;
begin
wu:=0;wn:=0;
while wu<eheh.height do begin
while wn<eheh.width do begin
eheh.canvas.draw(wn,wu,ahha);wn:=wn+ahha.width;
end;
wn:=0;wu:=wu+ahha.height;
end;
wn:=0;wu:=0;
end;
function bintobool(bin:string;bindex:byte):boolean;
begin
if(bindex<length(bin)) then begin
result:=strtobool(bin[length(bin)-bindex]);
end else begin result:=false;end;
end;

function changepic(s:byte):byte;
var str,bin:string;
var val:integer;
var x,y,z:integer;
var a,b,w,h:integer;
begin
w:=(form2.image1.width div 8);
h:=(form2.image1.height div 8);
str:=righto(stri,'=');

if (righto(stri,'=')='(None)') then begin end else begin
val:=strtoint(getstrdex(str,' ',0));
bin:=inttobin(val);

x:=0;
y:=0;
z:=7;
while x<8 do begin
y:=0;
while y<8 do begin
a:=x;
b:=z;
val:=strtoint(getstrdex(str,' ',y));
bin:=inttobin(val);
if(bintobool(bin,x)=true)then  begin
form2.image1.canvas.pen.color:=clblack;
form2.image1.canvas.brush.color:=clblack;
form2.image1.canvas.rectangle(z*w,y*h,(z*w)+w,(y*h)+h);
pix[z,y]:=true;
tb.canvas.pixels[z,y]:=clblack;
tc:=true;
end else begin
form2.image1.canvas.pen.color:=clbackground;
form2.image1.canvas.brush.color:=clbackground;
form2.image1.canvas.rectangle(z*w,y*h,(z*w)+w,(y*h)+h);
pix[z,y]:=false;
tb.canvas.pixels[z,y]:=clbackground;
end;
y:=y+1;
end;
x:=x+1;
z:=z-1;
end;
fillit(form2.image2.picture.bitmap,tb);
end;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
modalresult:=mrcancel;
end;

procedure TForm2.FormActivate(Sender: TObject);
var g:integer;

begin
lo:=tstringlist.create;
sec:=tstringlist.create;
ll:=tstringlist.create;
ini:=tinifile.create('control.ini');
wni:=tinifile.create('win.ini');
ini.readsection('Patterns',ComboBox1.items);
ini.readsectionvalues('Patterns',ll);
ini.readsectionvalues('Patterns',sec);
if(sec.count>-1)then begin sec.delete(0);end;
sec.sorted:=true;
if(ComboBox1.items.count>0)then ComboBox1.items.delete(0);
if not(wni.readstring('Desktop','Pattern','(None)')='(None)') then begin
combobox1.text:=wni.readstring('Desktop','Pattern','(None)');
end;
stri:=wni.readstring('Desktop','Pattern','(none)');
if(combobox1.text='(none)') then begin end else
begin
g:=0;
while (g<sec.count)do begin
if(righto(sec[g],'=')=combobox1.text) then begin
combobox1.text:=combobox1.items[g];
g:=sec.count;
end;
g:=g+1;
end;
end;

tb:=tbitmap.create;
tb.width:=8;
tb.height:=8;
tb.canvas.brush.color:=clBackground;
tb.canvas.pen.color:=clbackground;
tb.canvas.rectangle(0,0,tb.width,tb.height);
image1.canvas.brush.color:=clBackground;
image1.canvas.rectangle(0,0,image1.width,image1.height);
image2.canvas.brush.color:=clBackground;
image2.canvas.rectangle(0,0,image2.width,image2.height);
changepic(1);
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
ini.free;
wni.free;
tb.free;
sec.free;
ll.free;
lo.free;
end;

procedure TForm2.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var a,b,w,h:integer;
begin
if((x>0)and(x<image1.width))then mx:=x;
if((y>0)and(y<image1.width))then my:=y;
if(md=true)then begin
a:=(mx div (image1.width div 8));
b:=(my div (image1.height div 8));
w:=(image1.width div 8);
h:=(image1.height div 8);
if(pix[a,b]=false)and(tc=true)then  begin
image1.canvas.pen.color:=clblack;
image1.canvas.brush.color:=clblack;
image1.canvas.rectangle(a*w,b*h,(a*w)+w,(b*h)+h);
pix[a,b]:=true;
tb.canvas.pixels[a,b]:=clblack;
end else
if(pix[a,b]=true)and(tc=false)then  begin
begin
image1.canvas.pen.color:=clbackground;
image1.canvas.brush.color:=clbackground;
image1.canvas.rectangle(a*w,b*h,(a*w)+w,(b*h)+h);
pix[a,b]:=false;
tb.canvas.pixels[a,b]:=clbackground;
end;
end;
end;
fillit(image2.picture.bitmap,tb);
end;
procedure TForm2.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var a,b,w,h:integer;
begin
md:=true;
a:=(mx div (image1.width div 8));
b:=(my div (image1.height div 8));
w:=(image1.width div 8);
h:=(image1.height div 8);
if(pix[a,b]=false)then  begin
image1.canvas.pen.color:=clblack;
image1.canvas.brush.color:=clblack;
image1.canvas.rectangle(a*w,b*h,(a*w)+w,(b*h)+h);
pix[a,b]:=true;
tb.canvas.pixels[a,b]:=clblack;
tc:=true;
end else
begin
image1.canvas.pen.color:=clbackground;
image1.canvas.brush.color:=clbackground;
image1.canvas.rectangle(a*w,b*h,(a*w)+w,(b*h)+h);
pix[a,b]:=false;
tb.canvas.pixels[a,b]:=clbackground;
tc:=false;
end;
end;

procedure TForm2.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
md:=false;
fillit(image2.picture.bitmap,tb);
end;




procedure TForm2.ComboBox1Change(Sender: TObject);
var str,bin:string;
var val:integer;
var x,y,z:integer;
var a,b,w,h:integer;
begin
button4.enabled:=true;
button5.enabled:=false;
button6.enabled:=false;
if(combobox1.text='')then begin
button4.enabled:=false;
end;
if((combobox1.items.indexof(combobox1.text))>-1) then begin
button4.enabled:=false;
combobox1.itemindex:=combobox1.items.indexof(combobox1.text);
end;
if
(combobox1.itemindex>-1)and
(combobox1.items.indexof(combobox1.text)>-1)
then begin
button4.enabled:=false;
button5.enabled:=true;
button6.enabled:=true;
w:=(image1.width div 8);
h:=(image1.height div 8);
str:=righto(sec[combobox1.itemindex],'=');
val:=strtoint(getstrdex(str,' ',0));
bin:=inttobin(val);

x:=0;
y:=0;
z:=7;
while x<8 do begin
y:=0;
while y<8 do begin
a:=x;
b:=z;
val:=strtoint(getstrdex(str,' ',y));
bin:=inttobin(val);
if(bintobool(bin,x)=true)then  begin
image1.canvas.pen.color:=clblack;
image1.canvas.brush.color:=clblack;
image1.canvas.rectangle(z*w,y*h,(z*w)+w,(y*h)+h);
pix[z,y]:=true;
tb.canvas.pixels[z,y]:=clblack;
tc:=true;
end else begin
image1.canvas.pen.color:=clbackground;
image1.canvas.brush.color:=clbackground;
image1.canvas.rectangle(z*w,y*h,(z*w)+w,(y*h)+h);
pix[z,y]:=false;
tb.canvas.pixels[z,y]:=clbackground;
end;
y:=y+1;
end;
x:=x+1;
z:=z-1;
end;

fillit(image2.picture.bitmap,tb);
end;
end;
procedure TForm2.Button4Click(Sender: TObject);
var r:array[0..7] of byte;
x,y:integer;
n,d:string;
begin
ublic:=true;
x:=0;
y:=0;

while x<8 do begin
r[x]:=((strtobin(
inttostr(booltoint(pix[0,x]))+
inttostr(booltoint(pix[1,x]))+
inttostr(booltoint(pix[2,x]))+
inttostr(booltoint(pix[3,x]))+
inttostr(booltoint(pix[4,x]))+
inttostr(booltoint(pix[5,x]))+
inttostr(booltoint(pix[6,x]))+
inttostr(booltoint(pix[7,x]))
)));
inc(x);
end;
ini.writestring('Patterns',combobox1.text,
(
inttostr(r[0])+' '+
inttostr(r[1])+' '+
inttostr(r[2])+' '+
inttostr(r[3])+' '+
inttostr(r[4])+' '+
inttostr(r[5])+' '+
inttostr(r[6])+' '+
inttostr(r[7]))
);

n:=combobox1.text;
combobox1.clear;
sec.clear;
ll.clear;
ini:=tinifile.create('control.ini');
wni:=tinifile.create('win.ini');
ini.readsection('Patterns',ComboBox1.items);
if(comboBox1.items.count>-1)then ComboBox1.items.delete(0);
ini.readsection('Patterns',ll);
sec.sorted:=false;
ini.readsectionvalues('Patterns',sec);
if(sec.count>-1)then sec.delete(0);
sec.sorted:=true;
combobox1.text:=n;


end;

procedure TForm2.Button5Click(Sender: TObject);
var r:array[0..7] of byte;
x,y:integer;
n,d:string;
begin
ublic:=true;
x:=0;
y:=0;

while x<8 do begin
r[x]:=((strtobin(
inttostr(booltoint(pix[0,x]))+
inttostr(booltoint(pix[1,x]))+
inttostr(booltoint(pix[2,x]))+
inttostr(booltoint(pix[3,x]))+
inttostr(booltoint(pix[4,x]))+
inttostr(booltoint(pix[5,x]))+
inttostr(booltoint(pix[6,x]))+
inttostr(booltoint(pix[7,x]))
)));
inc(x);
end;
ini.writestring('Patterns',combobox1.text,
(
inttostr(r[0])+' '+
inttostr(r[1])+' '+
inttostr(r[2])+' '+
inttostr(r[3])+' '+
inttostr(r[4])+' '+
inttostr(r[5])+' '+
inttostr(r[6])+' '+
inttostr(r[7]))
);
n:=combobox1.text;
combobox1.clear;
sec.clear;
ll.clear;
ini:=tinifile.create('control.ini');
wni:=tinifile.create('win.ini');
ini.readsection('Patterns',ComboBox1.items);
if(comboBox1.items.count>-1)then ComboBox1.items.delete(0);
ini.readsection('Patterns',ll);
sec.sorted:=false;
ini.readsectionvalues('Patterns',sec);
if(sec.count>-1)then sec.delete(0);
sec.sorted:=true;
combobox1.text:=n;

end;

procedure TForm2.Button6Click(Sender: TObject);
var x:integer;
var n:string;
begin
ublic:=true;
ll.clear;
ini.readsectionvalues('Patterns',ll);
if(combobox1.items.indexof(combobox1.text)>-1)then begin
ini.erasesection('Patterns');
if(ll.count>-1)then ll.delete(combobox1.items.indexof(combobox1.text));
x:=0;
while (x<combobox1.items.count)and(x<ll.count)do begin
if(lefto(ll[x],'=')=combobox1.text)then begin end else begin
ini.writestring('Patterns',lefto(ll[x],'='),righto(ll[x],'='));
end;
x:=x+1;
end;

end;
n:=combobox1.text;
combobox1.clear;
sec.clear;
ini:=tinifile.create('control.ini');
wni:=tinifile.create('win.ini');
ini.readsection('Patterns',ComboBox1.items);
if(comboBox1.items.count>-1)then ComboBox1.items.delete(0);
ini.readsection('Patterns',ll);
sec.sorted:=false;
ini.readsectionvalues('Patterns',sec);
if(sec.count>-1)then begin sec.delete(0);end;
sec.sorted:=true;
combobox1.text:='';
end;

procedure TForm2.Button1Click(Sender: TObject);
type st=string;
var p:^st;
var S:string;
var I:longint;
var c:pchar;
var h:thandle;
var v:st;
begin
c:='this';

if(combobox1.items.indexof(combobox1.text)>-1)then begin
ini:=tinifile.create('control.ini');
wni:=tinifile.create('win.ini');
wni.writestring(
'Desktop',
'Pattern',
ini.readstring('Patterns',combobox1.text,'(None)')
);
end;
sendmessage(getdesktopwindow,WM_PAINT and HWND_BROADCAST,0,$28F7);
modalresult:=mrOK;
{close;}
end;

procedure TForm2.Button3Click(Sender: TObject);
begin
showmessage('watsay?');
end;

end.
