unit Unit3;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls,inifiles;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    ComboBox1: TComboBox;
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Image1: TImage;
    procedure Button5Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
ini:tinifile;
cni:tinifile;

implementation

{$R *.DFM}
function lefto(stringo,seperato:string):string; begin
result:=copy(stringo,0,pos(seperato,stringo)-1);
end;
function righto(stringon,seperaton:string):string; begin
result:=copy(stringon,pos(seperaton,stringon)+1,length(stringon));
end;



procedure TForm1.Button5Click(Sender: TObject);
begin
close;
end;

function ptw(tc:tcanvas):byte;
var bw:byte;
var rct:trect;
var b:tbitmap;
var r:integer;
begin
bw:=3;
r:=-3;
with tc do begin
brush.color:=clbackground;
pen.color:=clbackground;
rectangle(-1,-1,300,300);

brush.color:=clinactiveborder;
pen.color:=clwindowframe;
rectangle(10,10,200,120);
brush.color:=clinactivecaption;
rectangle(10+bw,10+bw,200-bw,120-bw);
font.color:=clinactivecaptiontext;
textout(75,14,'Inactive');
brush.color:=clmenu;
rectangle(10+bw,30+bw,200-bw,120-bw);
brush.color:=clappworkspace;
rectangle(10+bw,50+bw,200-bw,120-bw);
font.color:=clmenutext;
brush.color:=clmenu;
textout(20,35,'File  Edit');


brush.color:=clactiveborder;
pen.color:=clwindowframe;
rectangle(r+20,30,r+240,160);
brush.color:=clactivecaption;
rectangle(r+20+bw,30+bw,r+240-bw,160-bw);
font.color:=clcaptiontext;
textout(r+105,34,'Active');
brush.color:=clmenu;
rectangle(r+20+bw,50+bw,r+240-bw,160-bw);
brush.color:=clappworkspace;
rectangle(r+20+bw,70+bw,r+240-bw,160-bw);
font.color:=clmenutext;
brush.color:=clmenu;
textout(r+30,55,'File  Edit');
rectangle(r+20+bw,70+bw,r+112-bw,114-bw);
font.color:=clgraytext;
brush.color:=clmenu;
textout(r+30,75,'Disabled');
font.color:=clHighlightText;
brush.color:=clhighlight;
rectangle(r+20+bw,90+bw,r+112-bw,114-bw);
textout(r+30,93,'Highlighted');

pen.color:=clwindowframe;
brush.color:=clwindow;
rectangle(r+120,80,r+200,150);
brush.color:=clwindow;
font.color:=clwindowtext;
textout(r+135,82,'Window');
textout(r+145,100,'Text');
rct:=rect(r+130+1,120+1,r+190-1,145-1);
brush.color:=clbtnface;
pen.color:=clwindowframe;
{FrameRect(rct);}
rectangle(r+130,120,r+190,145);
frame3d(tc,rct,clbtnhighlight,clbtnshadow,bw);
textout(r+150,125,'OK');
brush.color:=clscrollbar;
pen.color:=clwindowframe;
rectangle(r+220,74,r+236,157);
b:=tbitmap.create;
b.loadfromfile('wu.bmp');
draw(r+221,75,b);
b.loadfromfile('wd.bmp');
draw(r+221,141,b);
b.free;
end;
end;






procedure TForm1.FormActivate(Sender: TObject);
var fir,sec:tstringlist;
var a,b:integer;
begin
ptw(image1.canvas);
sec:=tstringlist.create;
cni.readsectionvalues('color schemes',sec);
combobox1.text:=cni.readstring('current','color schemes','');
a:=0;

while a<sec.count do begin
combobox1.items.add(lefto(sec[a],'='));
a:=a+1;
end;



sec.free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
ini:=tinifile.create('win.ini');
cni:=tinifile.create('control.ini');
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
ini.free;
cni.free;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
showmessage('wat say?');
end;

end.
