unit Unit4;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls,inifiles, Spin, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    SpinButton1: TSpinButton;
    SpinButton2: TSpinButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit7: TEdit;
    Timer1: TTimer;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Edit1Enter(Sender: TObject);
    procedure Edit2Enter(Sender: TObject);
    procedure Edit3Enter(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
    procedure Edit4Enter(Sender: TObject);
    procedure Edit6Enter(Sender: TObject);
    procedure Edit5Enter(Sender: TObject);
    procedure Edit4Exit(Sender: TObject);
    procedure Edit7Enter(Sender: TObject);
    procedure GroupBox2Enter(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Edit5Exit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
ctal:boolean;
ini:tinifile;
tickcount:longint;
sd,st:byte;
sye,smo,swe,sda,sho,smi,sse,sds:word;
ye,mo,we,da,ho,mi,se,ds:word;
pye,pmo,pwe,pda,pho,pmi,pse,pds:word;
nye,nmo,nwe,nda,nho,nmi,nse,nds:word;
implementation

{$R *.DFM}



procedure GetDate(var Year, Month, Day, DayOfWeek: Word); assembler;
asm
	MOV	AH,2AH
	INT	21H
	XOR	AH,AH
	LES	DI,DayOfWeek
	STOSW
	MOV	AL,DL
	LES	DI,Day
	STOSW
	MOV	AL,DH
	LES	DI,Month
	STOSW
	XCHG	AX,CX
	LES	DI,Year
	STOSW
end;

procedure SetDate(Year, Month, Day: Word); assembler;
asm
	MOV	CX,Year
	MOV	DH,BYTE PTR Month
	MOV	DL,BYTE PTR Day
	MOV	AH,2BH
	INT	21H
end;

procedure GetTime(var Hour, Minute, Second, Sec100: Word); assembler;
asm
	MOV	AH,2CH
	INT	21H
	XOR	AH,AH
	MOV	AL,DL
	LES	DI,Sec100
	STOSW
	MOV	AL,DH
	LES	DI,Second
	STOSW
	MOV	AL,CL
	LES	DI,Minute
	STOSW
	MOV	AL,CH
	LES	DI,Hour
	STOSW
end;

procedure SetTime(Hour, Minute, Second, Sec100: Word); assembler;
asm
	MOV	CH,BYTE PTR Hour
	MOV	CL,BYTE PTR Minute
	MOV	DH,BYTE PTR Second
	MOV	DL,BYTE PTR Sec100
	MOV	AH,2DH
	INT	21H
end;

function settim:byte;
var h,m,s:byte;
begin
with form1 do begin
h:=strtoint(edit4.text);
if(edit7.text='PM') then h:=h+12;
m:=strtoint(edit5.text);
s:=strtoint(edit6.text);
settime(h,m,s,0);
end;
end;
procedure TForm1.Button2Click(Sender: TObject);
var tmp:longint;
var h,m,s:integer;
begin
tmp:=gettickcount-tickcount;
h:=tmp div (60*(60*1000));
m:=tmp div (60*1000);
s:=tmp div (1000);
if (ctal=true) then begin
settime(sho+h,smi+m,sse+s,sds);
end;
close;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
showmessage('wat say?');
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
gettime(ho,mi,se,ds);
if (not(st=1)) then begin
if(ho>12)then begin
{if(not(st=4))then edit7.text:='PM';}
ho:=ho-12;
end else begin
{if(not(st=4))then edit7.text:='AM';}
end;
edit4.text:=inttostr(ho);
end;

if not(st=2) then begin
if(mi<10) then begin
edit5.text:='0'+inttostr(mi);
end else begin
edit5.text:=inttostr(mi);
end;
end;

if not(st=3) then begin
if(se<10)then begin
edit6.text:='0'+inttostr(se);
end else begin
edit6.text:=inttostr(se);
end;
end;
end;


procedure TForm1.FormActivate(Sender: TObject);
begin
tickcount:=gettickcount;
gettime(sho,smi,sse,sds);
getdate(sye,smo,sda,swe);
getdate(ye,mo,da,we);
edit1.text:=inttostr(mo);
edit2.text:=inttostr(da);
edit3.text:=copy(inttostr(ye),3,4);



gettime(ho,mi,se,ds);
if(ho>12)then begin
edit7.text:='PM';
ho:=ho-12;
end else begin
edit7.text:='AM';
end;
edit4.text:=inttostr(ho);

edit5.text:=inttostr(mi);
edit6.text:=inttostr(se);
if(mi<10)then edit5.text:='0'+edit5.text;
if(se<10)then edit6.text:='0'+edit6.text;

end;

procedure TForm1.Edit1Enter(Sender: TObject);
begin
sd:=1;
end;

procedure TForm1.Edit2Enter(Sender: TObject);
begin
sd:=2;
end;

procedure TForm1.Edit3Enter(Sender: TObject);
begin
sd:=3;
end;

procedure TForm1.SpinButton1DownClick(Sender: TObject);
begin
if(sd=1)then begin
if(strtoint(edit1.text)<2)then begin
edit1.text:='12';
end else
begin
edit1.text:=inttostr(strtoint(edit1.text)-1);
end;
end;

if(sd=2)then begin
if(strtoint(edit2.text)<2)then begin
edit2.text:='31';
end else
begin
edit2.text:=inttostr(strtoint(edit2.text)-1);
end;
end;

if(sd=3)then begin
if(strtoint(edit3.text)=0)then begin
edit3.text:='99';
end else
begin
edit3.text:=inttostr(strtoint(edit3.text)-1);
if(strtoint(edit3.text)<10)then edit3.text:='0'+edit3.text;
end;
end;


end;

procedure TForm1.SpinButton1UpClick(Sender: TObject);
begin
if(sd=1)then begin
if(strtoint(edit1.text)>11)then begin
edit1.text:='1';
end else
begin
edit1.text:=inttostr(strtoint(edit1.text)+1);
end;
end;

if(sd=2)then begin
if(strtoint(edit2.text)>30)then begin
edit2.text:='1';
end else
begin
edit2.text:=inttostr(strtoint(edit2.text)+1);
end;
end;

if(sd=3)then begin
if(strtoint(edit3.text)>98)then begin
edit3.text:='1';
end else
begin
edit3.text:=inttostr(strtoint(edit3.text)+1);
if(strtoint(edit3.text)<10)then edit3.text:='0'+edit3.text;
end;
end;

end;

procedure TForm1.SpinButton2DownClick(Sender: TObject);
begin
if(st=4)then begin
if(edit7.text='AM')then begin edit7.text:='PM'; end else begin edit7.text:='AM';end;
end;

if(st=1)then begin
if(strtoint(edit4.text)<2)then begin
edit4.text:='12';
end else
begin
edit4.text:=inttostr(strtoint(edit4.text)-1);
end;
end;

if(st=2)then begin
if(strtoint(edit5.text)=0)then begin
edit5.text:='59';
end else
begin
edit5.text:=inttostr(strtoint(edit5.text)-1);
end;
end;

if(st=3)then begin
if(strtoint(edit6.text)=0)then begin
edit6.text:='59';
end else
begin
edit6.text:=inttostr(strtoint(edit6.text)-1);
end;
end;
settim;
end;

procedure TForm1.SpinButton2UpClick(Sender: TObject);
begin
if(st=4)then begin
if(edit7.text='AM')then begin edit7.text:='PM'; end else begin edit7.text:='AM';end;
end;

if(st=1)then begin
if(strtoint(edit4.text)>11)then begin
edit4.text:='1';
end else
begin
edit4.text:=inttostr(strtoint(edit4.text)+1);
end;
end;

if(st=2)then begin
if(strtoint(edit5.text)>59)then begin
edit5.text:='1';
end else
begin
edit5.text:=inttostr(strtoint(edit5.text)+1);
end;
end;

if(st=3)then begin
if(strtoint(edit6.text)>59)then begin
edit6.text:='1';
end else
begin
edit6.text:=inttostr(strtoint(edit6.text)+1);
end;
end;
settim;
end;

procedure TForm1.Edit4Enter(Sender: TObject);
begin
st:=1;
pho:=strtoint(edit4.text);
end;

procedure TForm1.Edit6Enter(Sender: TObject);
begin
st:=3;
end;

procedure TForm1.Edit5Enter(Sender: TObject);
begin
st:=2;
end;



procedure TForm1.Edit4Exit(Sender: TObject);
var h,m,s:byte;
begin
if(strtoint(edit4.text)>12)or(strtoint(edit4.text)<1)then
begin
edit4.text:=inttostr(pho);
end else
begin
settim;
end;
end;

procedure TForm1.Edit7Enter(Sender: TObject);
begin
st:=4;
end;

procedure TForm1.GroupBox2Enter(Sender: TObject);
begin
ctal:=true;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
settim;
setdate(
strtoint(inttostr((ye div 100)*100+strtoint(edit3.text))),
strtoint(edit1.text),
strtoint(edit2.text));


close;
end;

procedure TForm1.Edit5Exit(Sender: TObject);
var h,m,s:byte;
begin
if(strtoint(edit5.text)>59)or(strtoint(edit5.text)<1)then
begin
edit5.text:=inttostr(mi);
end else
begin
h:=strtoint(edit5.text);
if(edit7.text='PM') then h:=h+12;
m:=strtoint(edit5.text);
s:=strtoint(edit6.text);
settime(h,m,s,0);
end;

end;

end.
